//+------------------------------------------------------------------+
//|                                             boafxbaskethedge2019.mq4 |
//|                    Copyright 2019 BOAFX Trading Signal Solutions |
//|                                   https://www.boafx.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019 BOAFX Trading Signal Solutions"
#property link      "https://www.boafx.com"
#property version   "1.00"
#property strict


#include <stderror.mqh>
#include <stdlib.mqh>
enum TrailType{Regular,CandleTrail};

//--breakout trade settings

extern string Boafx_TSS_Trade_Settings;//Trade settings
extern double StopLoss=0;//Initial Stop Loss
extern double TakeProfit=250;//Take Profit
extern double RecoveryTakeProfit=25;//Recovery Take Profit
extern double Lotsize=0.01;//Initial Lotsize
//extern int TradeSpacing=30;
//extern int Threshold =5;
//extern int MaxAmountOfTrades=1;//Maximum amount of trades allowed for this strategy
//extern int MaxbasketTrades=3;//Maximum basket trades allowed

//---Breakeven Settings

 string Break_Even_Settings;//Breakeven Settings
 bool UseMoveToBE=false;//Use Move to Breakeven?
 int WhenToMoveToBE=25;//How many pips before you move?
 int PipsToLockIn=1;//How many pips do you want to lock in?

                          //Trailing Stop settings

 bool UseTrailingStop=true;//Use a Trailing StopLoss?
 TrailType Trailing_Type=Regular;//Which Type Of Trailing Stop Loss?

 string Regular_Trail_Settings;//Regular Trail Settings
 int  WhenToTrail=50;//How Many Pips Profit To Begin Trail?
 int  TrailAmount=25;//How many Pips TO Trail By?

 string Candle_Stop_Settings;
 int  CandlesBack=2;//How many candles back to Look  
 int  PadAmount=25;//How much beyond candle to put stop.
//---
 int Slippage=30;//Slippage Allowed On This Strategy
 int MagicSeed=1000;//Magic Number Seed Generator

 string Smartinggale_Settings;//Smartinggale Settings
 double SmartinggaleAmount=1;//Smartingggale amount 1 = plus 1 lotsize
 double HedgeRecoverySmartingale=2;//
 double MaxLotSize=.10;//Maximum Lotsize Allowed For This Strategy
 double  MinLotSize=0.01;//Set minimum lot size


input string  Password="";//Please Enter Your Password.
double pips;
int magic;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
 EventSetTimer(60);
   
//---
   if(TimeLocal()> D'01.06.2020'&& Password!="ahmadriyaji22@gmail.com")
   {
   MessageBox("This File Has Expired! Please puchase the license key from the merchant!","Expired File");
   Comment("The File was removed as it is past it's expiration date"+
   "\nPlease contact boafxtss@gmail.com to purchase the License key");
   ExpertRemove();
   return(INIT_FAILED);
   }
   if(!IsExpertEnabled()){
   MessageBox("You need to enable AutoTrading" ,"Please enable Autotrading!");
   Comment(WindowExpertName(),"is NOT running because you have AutoTrading Disabled!"+
   "\nPlease Enable AutoTrading and reload the expert.");
   ExpertRemove();
   return(INIT_FAILED);
   }
   if(!IsTradeAllowed()){
   MessageBox("You need to \"Allow Live Trading\"" ,"Please check \"Allow Live Trading\"!");
   Comment(WindowExpertName(),"is NOT running because you do not have \"Allow Live Trading\" enabled!"+
   "\nPlease Enable \"Alow Live Trading\" and reload the expert.");
   ExpertRemove();
   return(INIT_FAILED);
   }
   if(!IsDllsAllowed()){
   MessageBox("DLLs are NOT enabled!" ,"Please enable DLLs!");
   Comment(WindowExpertName(),"is NOT running because you have DLLs Disabled!"+
   "\nPlease Enable DLLs and reload the expert.");
   ExpertRemove();
   return(INIT_FAILED);
   }
   if(!IsLibrariesAllowed()){
   MessageBox("Allow import of external experts is NOT enabled!" ,"Please enable it!");
   Comment(WindowExpertName(),"is NOT running because you have external experts Disabled!"+
   "\nPlease Enable them and reload the expert.");
   ExpertRemove();
   return(INIT_FAILED);
   }
  
  
  
  

   magic=MagicNumberGenerator();
   Print("MagicNumber is ",magic);

// Determine what a pip is.
   pips=Point; //.00001 or .0001. .001 .01.
   if(Digits==3 || Digits==5)
      pips*=10;



   Comment("Expert Loaded Successfully");

//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   Comment(" ");
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
   for(int i=100;i>0;i--)
     {
      Comment(i);
     }
 CheckForSignal();
 if(UseTrailingStop)AdjustTrail();
   if(UseMoveToBE)MovetoBreakeven();
   
 
           
   
            
         
       
   
  
}
  
//+------------------------------------------------------------------+
//|       TRIGGER FUNCTION pull back STRATEGY                       |
//+------------------------------------------------------------------+
void CheckForSignal()
  {
   static datetime candletime=0;
   if(candletime!=Time[0])
     {
      double currenttrendMa30=iMA(NULL,30,50,0,1,0,1);
      double trendMa200=iMA(NULL,30,200,0,1,0,1);
      double currentMACD=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,1);
      double previouspreviousMACD=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,3);
      double previousMACD=iMACD(NULL,0,12,26,9,PRICE_CLOSE,MODE_MAIN,2);
      double upperbollingerband=iBands(NULL,0,20,2,0,PRICE_CLOSE,MODE_UPPER,1);
      double lowerbollingerband=iBands(NULL,0,20,2,0,PRICE_CLOSE,MODE_LOWER,1);

      //SELL signal 
      
      if((currentMACD < previousMACD && previousMACD < previouspreviousMACD && previousMACD <0 && previouspreviousMACD>0)|| (currentMACD < previousMACD && previousMACD > previouspreviousMACD && currentMACD > 45*pips))
        
         
        if(TotalOpenSellOrders())
         {
        
              
              
          if(Bid - HighestSellPosition() >= 30*pips)
            
         EnterTrade(OP_SELL);
      }
      else EnterTrade(OP_SELL);

       
        
      //BUY signal 
      
      
     if((currentMACD > previousMACD && previousMACD > previouspreviousMACD && previousMACD >0 && previouspreviousMACD<0)||(currentMACD > previousMACD && previousMACD < previouspreviousMACD && currentMACD < -45*pips))
      
         
      if(TotalOpenBuyOrders())
      {
       
        
        if(LowestBuyPosition()-Ask >= 30*pips)
               
                  EnterTrade(OP_BUY);
         }
         else EnterTrade(OP_BUY);
         
      candletime=Time[0];
     }
  }

//+------------------------------------------------------------------+
//|     TRADE PLACING FUNCTION                                                             |
//+------------------------------------------------------------------+
void EnterTrade(int type){

   int err=0;
   double price=0,
          sl=0, 
          tp=0,
          lotsize = 0;
              
          {
          price = Bid;
          if(TotalOpenBuyOrders()>3) lotsize = (TotalOpenBuyOrders()+SmartinggaleAmount)*Lotsize;
           else lotsize = (TotalOpenSellOrders()+SmartinggaleAmount)* Lotsize;
            
           }
   if(type == OP_BUY)
   {
   price =Ask;
   
   if (TotalOpenSellOrders()>3)  lotsize = (TotalOpenSellOrders()+SmartinggaleAmount)*Lotsize;
           
             else lotsize = (TotalOpenBuyOrders()+SmartinggaleAmount)*Lotsize;
             }
             
      
   
   
   //----
   int ticket =  OrderSend(Symbol(),type,lotsize,price,30,0,0,"normal trade",magic,0,Magenta); 
   if(ticket>0)
   {
      if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(OrderType() == OP_SELL)
         {
         
           sl = OrderOpenPrice()+(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp=OrderOpenPrice()-(TakeProfit*pips);
             if (TotalOpenSellOrders()>2)   tp = BreakevenOfSells()-(RecoveryTakeProfit*pips);
             
         }
         else if(OrderType()==OP_BUY)
         {
         
          sl = OrderOpenPrice()-(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp=OrderOpenPrice()+(TakeProfit*pips);
             if (TotalOpenBuyOrders()>2)   tp = BreakevenOfBuys()+(RecoveryTakeProfit*pips);
            
         }
         //---Modify This Order
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) 
         {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
          //---Modify The Other sell Orders that are Open.
         if(TotalOpenSellOrders() > 1)         
         {
            for(int i=0;i<OrdersTotal()-1;i++)
            {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  if(OrderMagicNumber()==magic)
                     if(OrderType()==OP_SELL)
                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,clrMagenta))                              
                        {
                           err = GetLastError();
                           Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                        }
                        
            }
         }
          //---Modify The Other buy Orders that are Open.
         if(TotalOpenBuyOrders() > 1)         
         {
            for(int i=0;i<OrdersTotal()-1;i++)
            {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                 if(OrderMagicNumber()==magic)
                     if(OrderType()==OP_BUY)
                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,clrMagenta))                              
                        {
                           err = GetLastError();
                           Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                        }
                        
            }
         }
         
      }
      else
      {//in case it fails to select the order for some reason 
         Print(__FUNCTION__,"Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else
   {//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placementb!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}
  
//+------------------------------------------------------------------+
//|      MOVE TO BREAK EVEN FUNCTION  Breakout TRADE                 |
//+------------------------------------------------------------------+

void   MovetoBreakeven()
  {
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderMagicNumber()==magic)
            if(OrderType()==OP_BUY && TotalOpenBuyOrders()<=2)
              {
               if(Bid-OrderOpenPrice()>WhenToMoveToBE*pips)
                  if(OrderStopLoss()<OrderOpenPrice())
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE))
                       {
                        int err=GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err));
                       }
              }
         else if(OrderType()==OP_SELL && TotalOpenSellOrders()<=2)
           {
            if(OrderOpenPrice()-Ask>WhenToMoveToBE*pips)
               if(OrderStopLoss()>OrderOpenPrice() || OrderStopLoss()==0)
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(PipsToLockIn*pips),OrderTakeProfit(),0,CLR_NONE))
                    {
                     int err=GetLastError();
                     Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err));
                    }
           }
        }
      else
        {//in case it fails to select an order.
         int err=GetLastError();
         Print("Encountered an error during order selection in: "+__FUNCTION__+"!"+(string)err+" "+ErrorDescription(err));
        }
     }
  }
//+------------------------------------------------------------------+
//|Adjust Trail  breakout trade                                                    |
//+------------------------------------------------------------------+
void AdjustTrail()
  {
   switch(Trailing_Type)
     {
      case Regular: RegularTrail();return;
      case CandleTrail: CandleTrail();return;
      default: return;
     }
//if (Trailing_Type==Regular){
//   RegularTrail();
//   return;
//}
//if (Trailing_Type==CandleTrail){
//   CandleTrail();
//   return;   
  }
//+------------------------------------------------------------------+
//| Trailing Stop Function  breakout trade                                         |
//+------------------------------------------------------------------+
void RegularTrail()
  {
 
 
   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderMagicNumber()==magic)
           
            if(OrderType()==OP_BUY && enableBuyTrail()==true)
            
              {
              
               if(Bid-OrderOpenPrice()>WhenToTrail*pips)
                  if(OrderStopLoss()<Bid-TrailAmount*pips)
                     if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE))
                       {
                        int err=GetLastError();
                        Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err));
                       }//ordermodify
              }//buy order 
         else if(OrderType()==OP_SELL && enableSellTrail()==true)
         
           {
           
            if(OrderOpenPrice()-Ask>WhenToTrail*pips)
               if(OrderStopLoss()>Ask+TrailAmount*pips || OrderStopLoss()==0)
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(TrailAmount*pips),OrderTakeProfit(),0,CLR_NONE))
                    {
                     int err=GetLastError();
                     Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err));
                    }//ordermodiy    
           }//sell order
        }//select an order
      else
        {//in case it fails to select an order.
         int err=GetLastError();
         Print("Encountered an error during order selection in: "+__FUNCTION__+"!"+(string)err+" "+ErrorDescription(err));
        }
     }//for loop
  }
//+------------------------------------------------------------------+
//|Candle Trail    breakout trade                                                  |
//+------------------------------------------------------------------+
void CandleTrail()
  {
   int buyStopCandle=iLowest(NULL,0,MODE_LOW,CandlesBack,1);
   int sellStopCandle=iHighest(NULL,0,MODE_HIGH,CandlesBack,1);
   for(int i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderMagicNumber()==magic)
            if(OrderType()==OP_BUY)
              {
               if(OrderStopLoss()<Low[buyStopCandle]-(PadAmount*pips))
                  if(OrderModify(OrderTicket(),OrderOpenPrice(),Low[buyStopCandle]-PadAmount*pips,OrderTakeProfit(),0,CLR_NONE))
                     OrderPrint();
               else
                 {    //if order did not get modified.
                  int err=GetLastError();
                  Print("Encountered an error on line "+(string)__LINE__+" during modification!"+(string)err+" "+ErrorDescription(err));
                 }
              }    //buy     
         else if(OrderType()==OP_SELL)
           {
            if(OrderStopLoss()>High[sellStopCandle]+(PadAmount*pips) || OrderStopLoss()==0)
               if(OrderModify(OrderTicket(),OrderOpenPrice(),High[sellStopCandle]+PadAmount*pips,OrderTakeProfit(),0,CLR_NONE))
                  OrderPrint();
            else
              {   //if order did not get modified.
               int err=GetLastError();
               Print("Encountered an error on line "+(string)__LINE__+" during modification!"+(string)err+" "+ErrorDescription(err));
              }
           } //sell     
        }//Orderselect
      else
        {   //in case it fails to select an order.
         int err=GetLastError();
         Print("Encountered an error during order selection in: "+__FUNCTION__+"!"+(string)err+" "+ErrorDescription(err));
        }
     }//for loop
  }
//+------------------------------------------------------------------+
//|  MAGIC NUMBER GENERATOR                                                                |
//+------------------------------------------------------------------+

int MagicNumberGenerator()
  {
   string mySymbol=StringSubstr(_Symbol,0,6);
   int pairNumber=0;
   int GeneratedNumber=0;
   if(mySymbol=="AUDCAD") pairNumber=1;
   else if(mySymbol == "AUDCHF")  pairNumber=2;
   else if(mySymbol == "AUDJPY")  pairNumber=3;
   else if(mySymbol == "AUDNZD")  pairNumber=4;
   else if(mySymbol == "AUDUSD")  pairNumber=5;
   else if(mySymbol == "CADCHF")  pairNumber=6;
   else if(mySymbol == "CADJPY")  pairNumber=7;
   else if(mySymbol == "CHFJPY")  pairNumber=8;
   else if(mySymbol == "EURAUD")  pairNumber=9;
   else if(mySymbol == "EURCAD")  pairNumber=10;
   else if(mySymbol == "EURCHF")  pairNumber=11;
   else if(mySymbol == "EURGBP")  pairNumber=12;
   else if(mySymbol == "EURJPY")  pairNumber=13;
   else if(mySymbol == "EURNZD")  pairNumber=14;
   else if(mySymbol == "EURUSD")  pairNumber=15;
   else if(mySymbol == "GBPAUD")  pairNumber=16;
   else if(mySymbol == "GBPCAD")  pairNumber=17;
   else if(mySymbol == "GBPCHF")  pairNumber=18;
   else if(mySymbol == "GBPJPY")  pairNumber=19;
   else if(mySymbol == "GBPNZD")  pairNumber=20;
   else if(mySymbol == "GBPUSD")  pairNumber=21;
   else if(mySymbol == "NZDCAD")  pairNumber=22;
   else if(mySymbol == "NZDJPY")  pairNumber=23;
   else if(mySymbol == "NZDCHF")  pairNumber=24;
   else if(mySymbol == "NZDUSD")  pairNumber=25;
   else if(mySymbol == "USDCAD")  pairNumber=26;
   else if(mySymbol == "USDCHF")  pairNumber=27;
   else if(mySymbol == "USDJPY")  pairNumber=28;
   GeneratedNumber=MagicSeed+(pairNumber*100)+_Period;
   return(GeneratedNumber);

  }
//+------------------------------------------------------------------+
//|               Total of All breakout Orders                                                   |
//+------------------------------------------------------------------+
int TotalOpenOrders()
  {
   int total=0;
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         //if(OrderMagicNumber()==magic)
            total++;

      else Print("",GetLastError());
     }
   return (total);
  }
//+---------------------------------------------------------------------+
//| how many trades of a certain type we have open for breakout trades  |                                                       
//+---------------------------------------------------------------------+
int OpenOrders(int dir)
  {
   int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         //if(OrderMagicNumber()==magic)
            if(OrderType()==dir)
               total++;
      else Print("Failed to select order dir",GetLastError());
     }
   return (total);
  }
//+------------------------------------------------------------------+
//|Gets Ticket Number of breakout last closed trade         |                                                 
//+------------------------------------------------------------------+

int lastTradeTicket()
  {
   int ticket=-1;
   for(int i=OrdersHistoryTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY))
         if(OrderMagicNumber()==magic)
           {
            ticket=OrderTicket();
            break;
           }

     }//for

   return(ticket);
  } //function

//+------------------------------------------------------------------+
//Total of all SELL orders place by this expert.
//+------------------------------------------------------------------+
int TotalOpenSellOrders()
{
  int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber()== magic)
            if(OrderType() == OP_SELL)
               total++;
      }
	   else Print(__FUNCTION__,"Failed to select order ",i," ",GetLastError());
	  }
   return (total);
}
//+------------------------------------------------------------------+
//Total of all BUY orders place by this expert.
//+------------------------------------------------------------------+
int TotalOpenBuyOrders()
{
  int total=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {
         if(OrderMagicNumber()== magic)
            if(OrderType() == OP_BUY)
               total++;
	   }
	   else Print(__FUNCTION__,"Failed to select order",GetLastError());
	  }
   return (total);
}

//+------------------------------------------------------------------+
//| find the price of the highest sell that is open                  |
//+------------------------------------------------------------------+
double HighestSellPosition()
{
	double HighestOpenPrice=0.0;
	for (int cnt=OrdersTotal()-1; cnt >= 0; cnt--)
   {
		if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
    		if(OrderMagicNumber()== magic)
    		   if(OrderType()==OP_SELL)
    		      if(OrderOpenPrice()>HighestOpenPrice)
		            HighestOpenPrice=OrderOpenPrice();
	}
   return(HighestOpenPrice);		
}
//+------------------------------------------------------------------+
//| find the price of the lowest buy that's open.                    |
//+------------------------------------------------------------------+

double LowestBuyPosition()
{
	double LowestOpenPrice=0.0;
	for (int cnt=OrdersTotal()-1; cnt >= 0; cnt--)
   {
    	if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
    	   if(OrderMagicNumber()== magic)
    	      if(OrderType()==OP_BUY)
    	         if(LowestOpenPrice==0.0)
	               LowestOpenPrice=OrderOpenPrice();
	            else if (OrderOpenPrice()<LowestOpenPrice)
	               LowestOpenPrice=OrderOpenPrice();
   }
	return(LowestOpenPrice);		
}

//+------------------------------------------------------------------+
//| Calculates Breakeven of Open Sell Orders.                                                                  |
//+------------------------------------------------------------------+
double BreakevenOfSells()
{
	double TotalLots = 0,
	       price = 0,
	       lots =0,
	       pricetimeslots =0,
	       Total =0,
	       TotalPriceTimesLots=0;
	for(int cnt=0;cnt<OrdersTotal();cnt++)
	{
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
		   if (OrderMagicNumber()== magic)
		      if(OrderType()==OP_SELL)
		      {
              price = OrderOpenPrice(); 
              lots = OrderLots();
              pricetimeslots = price * lots;
              TotalLots += lots;
              TotalPriceTimesLots += pricetimeslots;
            }
   }
              Total = TotalPriceTimesLots/TotalLots;
   return(Total);
}

//+------------------------------------------------------------------+
//| Calculates Breakeven of Open Buy Orders.                                                                  |
//+------------------------------------------------------------------+
double BreakevenOfBuys()
{
	double TotalLots = 0,
	       price = 0,
	       lots =0,
	       pricetimeslots =0,
	       Total =0,
	       TotalPriceTimesLots=0;
	for(int cnt=0;cnt<OrdersTotal();cnt++)
	{
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES))
		   if (OrderMagicNumber()== magic)
		      if(OrderType()==OP_BUY)
		      {
              price = OrderOpenPrice(); 
              lots = OrderLots();
              pricetimeslots = price * lots;
              TotalLots += lots;
              TotalPriceTimesLots += pricetimeslots;
            }
   }    
              Total = TotalPriceTimesLots/TotalLots;
   return(Total);
}

  
  //+------------------------------------------------------------------+
//|     OPPOSITE TRADE PLACING FUNCTION                                                             |
//+------------------------------------------------------------------+
void EnterOppositeTrade(int type, double lots){

   int err=0;
   double price=Bid,sl=0,tp=0,lotsize = (TotalOpenOrders()+HedgeRecoverySmartingale)*Lotsize;
   if(type == OP_SELL)
      {price =Ask;type = OP_BUY;}
   else type = OP_SELL;
   //----
   int ticket =  OrderSend(Symbol(),type,lotsize,price,30,0,0,"recovery Trade",magic,0,Magenta); 
   if(ticket>0){
      
      
     if(OrderSelect(ticket,SELECT_BY_TICKET))
      {
         if(OrderType() == OP_SELL)
         {
         
           sl = OrderOpenPrice()+(StopLoss*pips);
            if(StopLoss==0)sl=0;
            
            tp=OrderOpenPrice()-(RecoveryTakeProfit*pips);
              if (TotalOpenSellOrders()>1)   tp = BreakevenOfSells()-(TakeProfit*pips);
                
         }
         else if(OrderType()==OP_BUY)
         {
         
          sl = OrderOpenPrice()-(StopLoss*pips);
            if(StopLoss==0)sl=0;
            tp=OrderOpenPrice()+(RecoveryTakeProfit*pips);
              if (TotalOpenBuyOrders()>1)   tp = BreakevenOfBuys()+(TakeProfit*pips);
         }
          //---Modify This Order
         if(!OrderModify(ticket,price,sl,tp,0,Magenta)) 
         {
            err = GetLastError();
            Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
         }
         //---Modify The Other sell Orders that are Open.
         if(TotalOpenSellOrders() > 1)         
         {
            for(int i=0;i<OrdersTotal()-1;i++)
            {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  if(OrderMagicNumber()==magic)
                     if(OrderType()==OP_SELL)
                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,clrMagenta))                              
                        {
                           err = GetLastError();
                           Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                        }
                        
            }
         }
          //---Modify The Other buy Orders that are Open.
         if(TotalOpenBuyOrders() > 1)         
         {
            for(int i=0;i<OrdersTotal()-1;i++)
            {
               if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
                  if(OrderMagicNumber()==magic)
                     if(OrderType()==OP_BUY)
                        if(!OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),tp,0,clrMagenta))                              
                        {
                           err = GetLastError();
                           Print("Encountered an error during modification!"+(string)err+" "+ErrorDescription(err)  );
                        }
                        
            }
         }
         
      }
      else
      {//in case it fails to select the order for some reason 
         Print(__FUNCTION__,"Failed to Select Order ",ticket);
         err = GetLastError();
         Print("Encountered an error while seleting order "+(string)ticket+" error number "+(string)err+" "+ErrorDescription(err)  );
      }
   }
   else
   {//in case it fails to place the order and send us back a ticket number.
      err = GetLastError();
      Print("Encountered an error during order placementb!"+(string)err+" "+ErrorDescription(err)  );
      if(err==ERR_TRADE_NOT_ALLOWED)MessageBox("You can not place a trade because \"Allow Live Trading\" is not checked in your options. Please check the \"Allow Live Trading\" Box!","Check Your Settings!");
   }
}
//+------------------------------------------------------------------+
//|                  enable buy trailing stop loss              |
//+------------------------------------------------------------------+
bool enableBuyTrail(){
 if ((TotalOpenBuyOrders()<=3) && (TotalOpenSellOrders()>=0))
{
   return true;
   }
      return false;
      }
//+------------------------------------------------------------------+
//|                  enable sell trailing stop loss              |
//+------------------------------------------------------------------+
bool enableSellTrail(){
if((TotalOpenSellOrders()<=3)&& (TotalOpenBuyOrders()>=0))

{
   return true;
   }
      return false;
      }